<?php
/* utf8-marker = äöüß */

/*
 * Swiper_XH
 * @copyright   Frank Seidel, Olaf Penschke
 * @author      Frank Seidel    frase
 * @author      Olaf Penschke   olape
 * @version     1.0 RC1 (08.04.2020)
 * @link        http://fhseidel.de/ http://olaf.penschke.net/

 * @license     http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3
 
 * Swiper (MIT Licensed) https://swiperjs.com

================================================================================
*/

/*
 * Check if PLUGINLOADER is calling and die if not.
 */
if(!defined('PLUGINLOADER')) {
    die(
        'Plugin '. basename(dirname(__FILE__))
        . ' requires a newer version of the Pluginloader. No direct access.'
    );
}

//*********************************************************************************************
// dynamic menu under plugin

if(function_exists('XH_registerStandardPluginMenuItems')) {
    XH_registerStandardPluginMenuItems(true);
}
//*********************************************************************************************
// additional menu item in the dynamic menu
XH_registerPluginMenuItem(
$plugin, 
$plugin_tx['swiper']['backend_sets'], 
'?&swiper&admin=plugin_sets&action=plugin_text&normal', 
''
);
//*********************************************************************************************
if(XH_wantsPluginAdministration('swiper'))
{
    // additional line and tab in admin menu
    $o .= print_plugin_admin('on');
    pluginmenu('ROW');
    pluginmenu(
        'TAB', 
        '?&swiper&admin=plugin_sets&action=plugin_text&normal', 
        '', 
        XH_hsc($plugin_tx['swiper']['backend_sets'])
    );

    $o .= pluginmenu('SHOW');
//*********************************************************************************************
// menu in the plugin header line
    if(($admin != 'plugin_main') && ($admin != ''))
    {
        $o .= plugin_admin_common($action, $admin, $plugin);
    }
//*********************************************************************************************
//*********************************************************************************************
// additional CSS class for the configuration
    if((isset($_GET['swiper'])) 
          && (isset($_GET['admin'])) 
          && ($_GET['admin'] == 'plugin_config')) {
              $o = '<div class="swiper_conf">' . $o . '</div>';
    }
//*********************************************************************************************
//*********************************************************************************************
    $op_plugin_name = 'Swiper_XH';
    $op_plugin_version = '1.0 RC1';
    $op_copyright = '2019';
    $op_swiper_version = '(v. 5.3.6)';
    $op_cms_version_arr = array('1.7.0','1.7.1','1.7.2');
    $op_php_version = '5.6';
//*********************************************************************************************
//*********************************************************************************************
// display only on the start page of the plugin and under Info
    if(($admin == '') || ($admin == 'plugin_main')) {
        $o .= '<div class="swiperxh_admin">' . "\n";
        $o .= '<img class="swiperxh_admin_logo" alt="Logo Swiper_XH" src="' . $pth['folder']['plugins'] . 'swiper/img/logo-swiper-xh.svg">' . "\n";
        $o .= '<h1>' . $op_plugin_name . '</h1>' . "\n";
        $o .= '<p><strong>Version: ' . $op_plugin_version . '</strong></p>' . "\n";
        $o .= '<p>' . $plugin_tx['swiper']['admin_descr'] . '<br>' . "\n";
        $o .= '<a target="_blank" href="http://www.cmsimple-xh.org/">cmsimple-xh.org</a></p>' . "\n";
        $o .= '<p>© ' . $op_copyright . ' <a target="_blank" href="http://fhseidel.de/?CMSimple_XH-Stuff">Frank Seidel</a>,
               <a target="_blank" href="http://olaf.penschke.net/?CMSimple_XH/Plugins">Olaf Penschke</a></p>' . "\n";
        $o .= '<p>' . $plugin_tx['swiper']['admin_licence'] . "\n";
        $o .= '<strong>' . $op_plugin_name . '</strong> ' . $plugin_tx['swiper']['admin_gplv3_1'] . ' <a target="_blank" href="https://www.gnu.org/licenses/gpl-3.0.de.html">GPLv3</a> ' . $plugin_tx['swiper']['admin_gplv3_2'] . '</p>' . "\n";
        $o .= '<p>' . $plugin_tx['swiper']['admin_libSRC'] . ' ' . $op_swiper_version . "\n";
        $o .= '<p class="swiperHint"><a target="_blank" href="http://olaf.penschke.net/?Kontakt&xh_mailform_subject=' . $op_plugin_name . '">' . $plugin_tx['swiper']['admin_contact'] . '</a></p>' . "\n";
//*********************************************************************************************
// system check
//*********************************************************************************************
        $o .= '<h2>System Check</h2>';
        // FA
        if (function_exists('fa_require')) {
            $o .= '<p class="xh_success">' 
               . 'FA plugin &#x2192 is installed</p>' 
               . "\n";
        } else {
            $o .= '<p class="xh_fail">' 
               . 'FA plugin &#x2192 is not installed</p>' 
               . "\n";
        }
        // zip extension
        if(extension_loaded('zip')) {
            $o .= '<p class="xh_success">' 
               . 'ZIP Support &#x2192 is available</p>' 
               . "\n";
        } else {
            $o .= '<p class="xh_fail">' 
               . 'ZIP Support &#x2192 is not available</p>' 
               . "\n";
        }
        // CMSimple_XH Version
        $op_cms_version_tmp = CMSIMPLE_XH_VERSION;
        $op_cms_version_tmp = str_replace(array('CMSimple_XH '), '', $op_cms_version_tmp);
        if(in_array($op_cms_version_tmp, $op_cms_version_arr, true)) {
            $o .=    '<p class="xh_success">' 
                    . CMSIMPLE_XH_VERSION 
                    . ' &#x2192 supported</p>'
                    . "\n";
        } else {
            $o .=    '<p class="xh_fail">'
                    . CMSIMPLE_XH_VERSION 
                    . ' &#x2192 I hope it is still supported. It was designed for ' 
                    . $op_cms_version_arr[0] 
                    . ' - ' 
                    . end($op_cms_version_arr)
                    . '.</p>' 
                    . "\n";
        }
        // PHP version
        if(version_compare(phpversion(), $op_php_version, '<')) {
            $o .=    '<p class="xh_fail">PHP: ' 
                    . phpversion() 
                    . ' &#x2192 not supported</p>'
                    . "\n";
        } else {
            $o .=    '<p class="xh_success">PHP: ' 
                    . phpversion() 
                    . ' &#x2192 supported</p>' 
                    . "\n";
        }
        // write permissions
        $op_filename_arr =    array(
                                $pth['folder']['plugins'] . 'swiper/css/',
                                $pth['folder']['plugins'] . 'swiper/css/stylesheet.css',
                                $pth['folder']['plugins'] . 'swiper/config/',
                                $pth['folder']['plugins'] . 'swiper/config/config.php',
                                $pth['folder']['plugins'] . 'swiper/languages/',
                                $pth['folder']['plugins'] . 'swiper/languages/' . $sl . '.php',
                                $pth['folder']['userfiles'] . 'swiper-sets/',
                                $pth['folder']['userfiles'] . 'swiper-sets/images/');
        foreach($op_filename_arr as $op_filename) {
            if(is_writable($op_filename)) {
                $o .=    '<p class="xh_success">'
                        . $op_filename
                        . ' &#x2192 writable</p>'
                        . "\n";
            } else {
                $o .=    '<p class="xh_fail">'
                        . $op_filename
                        . ' &#x2192 not writable</p>'
                        . "\n";
            }
        }
        $o .= '</div>';
    }
//*********************************************************************************************
    // display under sets
    if($admin == 'plugin_sets') {
        if (function_exists('fa_require')) {
            fa_require();
        }
        $o .= '<h1>Swiper Sets</h1>' . "\n";
        $o .= '<div class="swiperxh_admin">' . "\n";
        $o .= '<div class="swiper_sets">' . "\n";
        $o .= '<div class="swiper_sets-unzip">' . "\n";
        $o .= '<h2>' . $plugin_tx['swiper']['backend_sets_zips'] . '</h2>' . "\n";
        $o .= '<p>' . $plugin_tx['swiper']['backend_sets_info'] . '</p>' . "\n";
        $o .= op_SW_SetZip();
        $o .= "\n" . '</div>' . "\n";
        $o .= '<div class="swiper_sets-folders">' . "\n";
        $o .= '<h2>' . $plugin_tx['swiper']['backend_sets_folders'] . '</h2>' . "\n";
        $o .= op_SW_SetFolder();
        $o .= "\n" . '</div>';
        $o .= "\n" . '</div>';
        $o .= "\n" . '</div>';
    }
}
//*********************************************************************************************
// if call unzip sets (function op_SW_UnZip())
    if((isset($_GET['unzip'])) && ($_GET['unzip'] != '')) {
        $op_zip_file = $_GET['unzip'];

        $op_unzip = op_SW_UnZip($op_zip_file);
        if($op_unzip !== false) {
            $_GET['unzip'] = '';
            // todo, check is_writable before unlink
            unlink(op_SW_SetPath() . $op_zip_file);
            header('Location: ?&swiper&admin=plugin_sets&wasunzip=success', true, 303);
        } else {
            header('Location: ?&swiper&admin=plugin_sets&wasunzip=fail', true, 303);
        }
    }
//*********************************************************************************************
// outputs a message (successful or failed) for unzip
    if((isset($_GET['wasunzip'])) && ($_GET['wasunzip'] != '')) {

        $op_sw_message = $_GET['wasunzip'];

        if($op_sw_message == 'success') {
            $o = XH_message('success', $plugin_tx['swiper']['backend_sets_unzip-success']) . $o;
        }
        if($op_sw_message == 'fail') {
            $o = XH_message('fail', $plugin_tx['swiper']['backend_sets_unzip-fail']) . $o;
        }
    }
//*********************************************************************************************
// add tab
if(XH_ADM && $s >= 0) {
    // is global true
    if($plugin_cf['swiper']['swiper-tab_no-hidden'] == 'true') {
        $pd_router->add_tab(
            $plugin_tx['swiper']['swiper_tab'],
            $pth['folder']['plugins'] . 'swiper/swiper_view.php'
        );
    } else {
        // is hidden, ($xh_publisher->isHidden($s) only works in preview mode, not when editing)
        $pd_array = $pd_router->find_page($s);
        if($pd_array['linked_to_menu'] == '0') {
            $pd_router->add_tab(
            $plugin_tx['swiper']['swiper_tab'],
            $pth['folder']['plugins'] . 'swiper/swiper_view.php'
            );
        }
    }
}
//*********************************************************************************************