<?php
/* utf8-marker = äöüß */

/*
 * Swiper_XH
 * @copyright   Frank Seidel, Olaf Penschke
 * @author      Frank Seidel    frase
 * @author      Olaf Penschke   olape
 * @version     1.0 RC1 (08.04.2020)
 * @link        http://fhseidel.de/ http://olaf.penschke.net/

 * @license     http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3
 
 * Swiper (MIT Licensed) https://swiperjs.com

================================================================================
*/

header('Content-type: text/css;');

if(isset($_GET['sw_name'])) {
    $sw_name = rawurldecode($_GET['sw_name']);
} else {
    $sw_name = '';
}
if(isset($_GET['sw_c_w'])) {
    $sw_Container_Width = rawurldecode($_GET['sw_c_w']);
} else {
    $sw_Container_Width = 'auto';
}
if(isset($_GET['sw_c_h'])) {
    $sw_Container_Height = rawurldecode($_GET['sw_c_h']);
} else {
    $sw_Container_Height = 'auto';
}
if(isset($_GET['sw_t_c'])) {
    $sw_ThemeColor = rawurldecode($_GET['sw_t_c']);
} else {
    $sw_ThemeColor = '';
}
if(isset($_GET['sw_b_s'])) {
    $sw_PaginationBulletSize = rawurldecode($_GET['sw_b_s']);
} else {
    $sw_PaginationBulletSize = '';
}
if(isset($_GET['sw_a_s'])) {
    $sw_HideArrowsSize = rawurldecode($_GET['sw_a_s']);
} else {
    $sw_HideArrowsSize = '';
}
if(isset($_GET['sw_s_p'])) {
    $sw_SlidePadding = rawurldecode($_GET['sw_s_p']);
} else {
    $sw_SlidePadding = '';
}
if(isset($_GET['sw_c_m'])) {
    $sw_Container_Margin = rawurldecode($_GET['sw_c_m']);
} else {
    $sw_Container_Margin = '';
}
if(isset($_GET['sw_b_ic'])) {
    $sw_PaginationBulletInactiveColor = rawurldecode($_GET['sw_b_ic']);
} else {
    $sw_PaginationBulletInactiveColor = '';
}

//==============================================================================
?>

/*
 * Swiper_XH
 * Frank Seidel, Olaf Penschke
 */

/* The following line is mandatory. Do not delete it! */
<?php if($sw_name != '') :?>

    <?php if($sw_ThemeColor != '') :?>
    .<?php echo $sw_name;?> {
        --swiper-theme-color: <?php echo $sw_ThemeColor;?>;
    }
    <?php endif?>

    .<?php echo $sw_name;?> {
        width: <?php echo $sw_Container_Width;?>;
        height: <?php echo $sw_Container_Height;?>;
        <?php if($sw_Container_Margin != '') :?>
            margin: <?php echo $sw_Container_Margin;?>;
        <?php endif?>
    }

    <?php if($sw_SlidePadding != '') :?>
    .<?=$sw_name;?> .swiper-slide {
        padding: <?php echo $sw_SlidePadding;?>;
        box-sizing: border-box;
    }
    <?php endif?>

    <?php if($sw_PaginationBulletSize != '') :?>
    .<?php echo $sw_name;?> .swiper-pagination-bullet {
        width: <?php echo $sw_PaginationBulletSize;?>;
        height: <?php echo $sw_PaginationBulletSize;?>;
    }
    <?php endif?>

    <?php if($sw_PaginationBulletInactiveColor != '') :?>
    .<?=$sw_name;?> .swiper-pagination-bullet:not(.swiper-pagination-bullet-active) {
        background: <?php echo $sw_PaginationBulletInactiveColor;?>;
        opacity: .5;
    }
    <?php endif?>

    <?php if($sw_HideArrowsSize != '') :?>
    .<?php echo $sw_name;?> {
        --swiper-navigation-size: <?php echo $sw_HideArrowsSize;?>;
    };
    <?php endif?>

/* for the background image selected in the tab Swiper */
    .<?=$sw_name;?> .swiper-slide {
     background-position: center center;
     background-size: cover;
    }

/* for - hideOnClick    Toggle navigation buttons visibility after click on Slider's container */
    .<?=$sw_name;?> .swiper-button-hidden {
    display: none!important;
    }

/* The following line is mandatory. Do not delete it! */
<?php endif?>