<?php
/* utf8-marker = äöüß */

/*
 * Swiper_XH
 * @copyright   Frank Seidel, Olaf Penschke
 * @author      Frank Seidel    frase
 * @author      Olaf Penschke   olape
 * @version     1.0 RC1 (08.04.2020)
 * @link        http://fhseidel.de/ http://olaf.penschke.net/

 * @license     http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3
 
 * Swiper (MIT Licensed) https://swiperjs.com

================================================================================
*/

require_once(__DIR__ . '/swiperfuncs.php');

//==============================================================================

/*
 * Check if PLUGINLOADER is calling and die if not.
 */
if(!defined('PLUGINLOADER')) {
    die(
        'Plugin '. basename(dirname(__FILE__))
        . ' requires a newer version of the Pluginloader. No direct access.'
    );
}
//==============================================================================

// add PageData
$pd_router->add_interest('sw_slider_bgcolor');
$pd_router->add_interest('sw_slider_bgimg');

// return full Swpiper
function op_Swiper($sw_set = '') {

global $pth, $bjs, $hjs, $plugin_cf;

    // initialize var
    $sw_pages = '';
    $sw_template = '';
    $sw_gallery = '';
    // set the default mode 
    $sw_mode = 'auto';

    // default settings with options of the plugin config
    $sw_ShowPagination = $plugin_cf['swiper']['swiper-pagination_enabled'];
    $sw_ShowArrows = $plugin_cf['swiper']['swiper-navigation_arrows'];
    $sw_ShowScrollbar = $plugin_cf['swiper']['swiper-scrollbar_enabled'];
    $sw_ThemeColor = $plugin_cf['swiper']['swiper-theme_color'];


    // include sets --> include.php
    // with $sw_template, $sw_ShowPagination, $sw_ShowArrows, $sw_ShowScrollbar, $sw_ThemeColor, $pageSeries
    if((trim($sw_set) != '')
    && (is_readable(op_SW_SetPath() . $sw_set . '/include.php'))) {
        require_once(op_SW_SetPath() . $sw_set . '/include.php');
        // pageSeries from include.php
        // 'isset' because from external set
        if((isset($sw_pageSeries)) && (trim($sw_pageSeries) != '')) {
            $sw_pages = $sw_pageSeries;
            $sw_mode = 'pageSeries';
        }
        // sw_template from include.php
        // a call in template or newsbox must have pageSeries
        // 'isset' because from external set
        // !!! since 1.0 RC1 no longer required !!!
        if((isset($sw_template)) && (trim($sw_template) == 'true')) {
            $sw_mode = 'pageSeries';
        }
    }

    // check input
    $sw_gallery = trim($sw_gallery);
    if(($sw_gallery != 'true') 
    || (!(is_readable(op_SW_SetPath() . $sw_set . '/ini.js')))) {
        $sw_gallery = '';
    }
    //
    $sw_ShowPagination = trim($sw_ShowPagination);
    if($sw_ShowPagination != 'true') {$sw_ShowPagination = '';}
    //
    $sw_ShowArrows = trim($sw_ShowArrows);
    if($sw_ShowArrows != 'true') {$sw_ShowArrows = '';}
    //
    $sw_ShowScrollbar = trim($sw_ShowScrollbar);
    if($sw_ShowScrollbar != 'true') {$sw_ShowScrollbar = '';}
    //
    // hex, hex with alpha, rgb, rgba, hsl, hsla
    $sw_ThemeColor = trim($sw_ThemeColor);
    if(!((substr($sw_ThemeColor, 0, 1) == '#')
    || (substr($sw_ThemeColor, 0, 3) == 'rgb')
    || (substr($sw_ThemeColor, 0, 3) == 'hsl'))) {
        $sw_ThemeColor = '';
    }

    // default settings with options of the plugin config
    $sw_Container_Width = trim($plugin_cf['swiper']['swiper-container_width']); // todo: check input
    $sw_Container_Height = trim($plugin_cf['swiper']['swiper-container_height']); // todo: check input

    $sw_SlidePadding = trim($plugin_cf['swiper']['swiper-slider_padding']); // todo: check input
    $sw_Container_Margin = trim($plugin_cf['swiper']['swiper-container_margin']); // todo: check input

    $sw_ParametersDirection = $plugin_cf['swiper']['swiper-parameters_direction'];
    $sw_ParametersSpeed = trim($plugin_cf['swiper']['swiper-parameters_speed']);
    if(ctype_digit($sw_ParametersSpeed) === false) {
        $sw_ParametersSpeed = '';
    }
    $sw_ParametersAutoHeight = $plugin_cf['swiper']['swiper-parameters_autoHeight'];
    $sw_ParametersEffect = $plugin_cf['swiper']['swiper-parameters_effect'];
    $sw_ParametersCrossFade = $plugin_cf['swiper']['swiper-parameters_crossFade'];
    $sw_ParametersSpaceBetween = trim($plugin_cf['swiper']['swiper-parameters_spaceBetween']);
    if(ctype_digit($sw_ParametersSpaceBetween) === false) {
        $sw_ParametersSpaceBetween = '';
    }
    $sw_ParametersGrabCursor = $plugin_cf['swiper']['swiper-parameters_grabCursor'];
    $sw_ParametersLoop = $plugin_cf['swiper']['swiper-parameters_loop'];

    $sw_ParametersAutoplay = $plugin_cf['swiper']['swiper-parameters_autoplay'];
    $sw_ParametersDelay = trim($plugin_cf['swiper']['swiper-parameters_delay']);
    if(ctype_digit($sw_ParametersDelay) === false) {
        $sw_ParametersDelay = '';
    }
    $sw_ParametersAutoStopLast = $plugin_cf['swiper']['swiper-parameters_autoStopLast'];
    $sw_ParametersDisableOnInteraction = $plugin_cf['swiper']['swiper-parameters_disableOnInteraction'];

    $sw_ParametersFreeMode = $plugin_cf['swiper']['swiper-parameters_freeMode'];

    $sw_PaginationType = $plugin_cf['swiper']['swiper-pagination_type'];
    $sw_PaginationBulletSize = trim($plugin_cf['swiper']['swiper-pagination_bulletSize']); // todo: check input
    $sw_PaginationDynamicBullets = $plugin_cf['swiper']['swiper-pagination_dynamicBullets'];
    $sw_PaginationDynamicMainBullets = trim($plugin_cf['swiper']['swiper-pagination_dynamicMainBullets']);
    if(ctype_digit($sw_PaginationDynamicMainBullets) === false) {
        $sw_PaginationDynamicMainBullets = '';
    }
    $sw_PaginationBulletsClickable = $plugin_cf['swiper']['swiper-pagination_bulletsClickable'];
    if($plugin_cf['swiper']['swiper-pagination_bulletsInactiveColor'] == 'dark') {
        $sw_PaginationBulletInactiveColor ='#000';
    } else {
        $sw_PaginationBulletInactiveColor = '#fff';
    }

    $sw_HideArrowsOnClick = $plugin_cf['swiper']['swiper-navigation_arrowsHideOnClick'];
    $sw_HideArrowsSize = trim($plugin_cf['swiper']['swiper-navigation_arrowsSize']); // todo: check input
    $sw_KeyboardEnabled = $plugin_cf['swiper']['swiper-navigation_keyboardEnabled'];
    $sw_MouseWheelEnabled = $plugin_cf['swiper']['swiper-navigation_mousewheelEnabled'];

    $sw_ScrollbarHide = $plugin_cf['swiper']['swiper-scrollbar_hide'];
    $sw_ScrollbarDraggable = $plugin_cf['swiper']['swiper-scrollbar_draggable'];

    // css and scripts only 1x embed
    static $op_sc_count = 1;

    // set swipername
    $sw_name = 'SW-' . $op_sc_count;

    // initialize var
    $o_tmp = '';
    // to include css files
    static $inctmp = '';

    // embed swiper.min.css only 1x
    if($op_sc_count < 2) {
        // is the call in the template can no be written to $hjs anymore
        // --> therefore insert with XH_afterFinalCleanUp
        $inctmp .= op_SW_swiper_min_css();
    }

    if(($sw_set != '')
    && (is_readable(op_SW_SetPath() . $sw_set . '/stylesheet.php'))) {
        // additional css from set
        $get_sw_set = '?sw_name=' . rawurlencode($sw_name);
        ($sw_ThemeColor != ''
            ? $get_sw_set .= '&sw_t_c=' . rawurlencode($sw_ThemeColor) : '');

        $inctmp .= '<link rel="stylesheet" href="' 
                . op_SW_SetPath() . $sw_set . '/stylesheet.php'
                . $get_sw_set
                . '" type="text/css">' 
                . "\n";
    } else {
        // additional default css file with options of the plugin config
        $get_default = '?sw_name=' . $sw_name;
        ($sw_Container_Width != '' ? $get_default .= '&sw_c_w=' . rawurlencode($sw_Container_Width) : '');
        ($sw_Container_Height != '' ? $get_default .= '&sw_c_h=' . rawurlencode($sw_Container_Height) : '');
        ($sw_SlidePadding != '' ? $get_default .= '&sw_s_p=' . rawurlencode($sw_SlidePadding) : '');
        ($sw_Container_Margin != '' ? $get_default .= '&sw_c_m=' . rawurlencode($sw_Container_Margin) : '');
        ($sw_PaginationBulletSize != '' ? $get_default .= '&sw_b_s=' . rawurlencode($sw_PaginationBulletSize) : '');
        $get_default .= '&sw_b_ic=' . rawurlencode($sw_PaginationBulletInactiveColor);
        ($sw_HideArrowsSize != '' ? $get_default .= '&sw_a_s=' . rawurlencode($sw_HideArrowsSize) : '');
        //
        ($sw_ThemeColor != '' ? $get_default .= '&sw_t_c=' . rawurlencode($sw_ThemeColor) : '');

        $inctmp .= '<link rel="stylesheet" href="' 
                . $pth['folder']['plugins'] . 'swiper/css/swiperdefault.css.php' 
                . $get_default 
                . '" type="text/css">' 
                . "\n";
    }

    // is the call in the template can no be written to $hjs anymore
    // --> therefore insert with XH_afterFinalCleanUp
    $GLOBALS['SW_incphpcss'] = $inctmp;
    if($op_sc_count < 2) {
        function addSwiperCSS($html) {
            $php_css = str_ireplace('</head>', $GLOBALS['SW_incphpcss'] . '</head>' , $html);
            return $php_css;
        }
         XH_afterFinalCleanUp('addSwiperCSS');
    }

    // insert Swiper
    $op_SW_Slider_tmp = op_SW_MakeSwipePages($sw_mode, $sw_pages);

    // start swiper container
    $o_tmp .= '<div class="swiper-container ' . $sw_name . '">' . "\n";
    // start swiper-wrapper
    $o_tmp .= '<div class="swiper-wrapper">' . "\n";
    // insert slides
    $o_tmp .= $op_SW_Slider_tmp;
    // end swiper-wrapper
    $o_tmp .= '</div>'. "\n";
    if($sw_ShowPagination == 'true') {
        // pagination
        $o_tmp .= '<div class="swiper-pagination"></div>'. "\n";
    }
    if($sw_ShowArrows == 'true') {
        // navigation buttons
        $o_tmp .= '<div class="swiper-button-prev"></div>';
        $o_tmp .= '<div class="swiper-button-next"></div>'. "\n";
    }
    if($sw_ShowScrollbar == 'true') {
        // scrollbar
        $o_tmp .= '<div class="swiper-scrollbar"></div>'. "\n";
    }
    // end swiper-container
    $o_tmp .= '</div>'. "\n";

    // if gallery
    if($sw_gallery == 'true') {
        // start swiper container for thumbs
        $o_tmp .= '<div class="swiper-container ' . $sw_name . '-thumbs">' . "\n";
        // start swiper-wrapper for thumbs
        $o_tmp .= '<div class="swiper-wrapper">' . "\n";
        // insert slides for thumbs
        $o_tmp .= $op_SW_Slider_tmp;
        // end swiper-wrapper for thumbs
        $o_tmp .= '</div>'. "\n";
        // end swiper-container for thumbs
        $o_tmp .= '</div>'. "\n";
    }

    // include js-scripts only 1x
    if($op_sc_count < 2) {
        // async does not work
        $bjs .= '<script src="' 
             . $pth['folder']['plugins'] 
             . 'swiper/js/swiper.min.js"></script>' 
             . "\n";
    }

    if(($sw_set != '')
    && (is_readable(op_SW_SetPath() . $sw_set . '/ini.js'))) {
        // include sets --> initial script
        $op_Scripttmp = file_get_contents(op_SW_SetPath() . $sw_set . '/ini.js');
        $op_Scripttmp = str_replace('###sw_name###', $sw_name, $op_Scripttmp);
        $bjs_tmp = '<script> ' 
                . $op_Scripttmp 
                . '</script>' . "\n";
    } else {
        // default initial script with options of the plugin config
        $bjs_tmp = '<script>
                var mySwiper = new Swiper(\'.' . $sw_name . '\', {';
        $bjs_tmp .= "\n" 
                 . 'direction: \'' . $sw_ParametersDirection . '\','
                 . ($sw_ParametersSpeed != '' ? ' speed: ' . $sw_ParametersSpeed . ', ' : '') .
                 'autoHeight: ' . ($sw_ParametersAutoHeight == 'true' ? 'true' : 'false') . ',
                 effect: \'' . $sw_ParametersEffect . '\',
                 crossFade: ' . ($sw_ParametersCrossFade == 'true' ? 'true' : 'false') . ','
                 . ($sw_ParametersSpaceBetween != '' ? ' spaceBetween: ' . $sw_ParametersSpaceBetween . ', ' : '') .
                 'grabCursor: ' . ($sw_ParametersGrabCursor == 'true' ? 'true' : 'false') . ',
                 loop: ' . ($sw_ParametersLoop == 'true' ? 'true' : 'false') . ',
                 freeMode: ' . ($sw_ParametersFreeMode == 'true' ? 'true' : 'false') . ',';
        if($sw_ParametersAutoplay  == 'true') {
            $bjs_tmp .= "\n" 
                     . 'autoplay: {'
                     . ($sw_ParametersDelay != '' ? 'delay: ' . $sw_ParametersDelay . ', ' : '') . 
                     'stopOnLastSlide: ' . ($sw_ParametersAutoStopLast == 'true' ? 'true' : 'false') . ',
                     disableOnInteraction: ' . ($sw_ParametersDisableOnInteraction == 'true' ? 'true' : 'false') . ',
                     },';
        }
        if($sw_ShowPagination == 'true') {
            $bjs_tmp .= "\n" 
                     . 'pagination: {
                     el: \'.swiper-pagination\',
                     type: \'' . $sw_PaginationType . '\',
                     dynamicBullets: ' . ($sw_PaginationDynamicBullets == 'true' ? 'true' : 'false') . ','
                     . ($sw_PaginationDynamicMainBullets != '' ? ' dynamicMainBullets: ' . $sw_PaginationDynamicMainBullets . ', ' : '') .
                     'clickable: ' . ($sw_PaginationBulletsClickable == 'true' ? 'true' : 'false') . ',
                     },';
        }
        if($sw_ShowArrows == 'true') {
            $bjs_tmp .= "\n" 
                     . 'navigation: {
                     nextEl: \'.swiper-button-next\',
                     prevEl: \'.swiper-button-prev\',
                     hideOnClick: ' . ($sw_HideArrowsOnClick == 'true' ? 'true' : 'false') . ',
                     },';
        }
        if($sw_KeyboardEnabled == 'true') {
            $bjs_tmp .= "\n" 
                     . 'keyboard: {
                     enabled: true,
                     },';
        }
        if($sw_MouseWheelEnabled == 'true') {
            $bjs_tmp .= "\n" 
                     . 'mousewheel: {
                     enabled: true,
                     },';
        }
        if($sw_ShowScrollbar == 'true') {
            $bjs_tmp .= "\n" 
                     . 'scrollbar: {
                     el: \'.swiper-scrollbar\',
                     hide: ' . ($sw_ScrollbarHide == 'true' ? 'true' : 'false') . ',
                     draggable: ' . ($sw_ScrollbarDraggable == 'true' ? 'true' : 'false') . ',
                     },';
        }
        $bjs_tmp .=  "\n" 
                 . '});';
        $bjs_tmp .= '</script>' . "\n";
    }

    // multiple spaces reduced to one
    $bjs_tmp = preg_replace('#[\s]{2,}#s', ' ', $bjs_tmp);
    $bjs .= $bjs_tmp;

    // css and scripts only 1x embed
    $op_sc_count++;

    return $o_tmp;
}
