<?php
/* utf8-marker = äöüß */

/*
 * Swiper_XH
 * @copyright   Frank Seidel, Olaf Penschke
 * @author      Frank Seidel    frase
 * @author      Olaf Penschke   olape
 * @version     1.0 RC1 (08.04.2020)
 * @link        http://fhseidel.de/ http://olaf.penschke.net/

 * @license     http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3
 
 * Swiper (MIT Licensed) https://swiperjs.com

================================================================================
 
 * @package   Metatags
 * @author    Martin Damken <kontakt@zeichenkombinat.de>
 * @author    The CMSimple_XH developers <devs@cmsimple-xh.org>
 * @copyright 2009-2017 The CMSimple_XH developers <http://cmsimple-xh.org/?The_Team>
 * @license   http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3
 * @link      http://cmsimple-xh.org/

================================================================================
*/

function swiper_view(array $page) {
    global $sn, $pth, $su, $plugin_tx, $plugin_cf, $bjs;

    // set $var from language-file
    $lang = $plugin_tx['swiper'];

    // list images for drop-filed
    $sw_bgimg_imgdropfield = op_SW_ImgDropField('option');

    $my_fields = array('sw_slider_bgcolor', 'sw_slider_bgimg');

    // pre defined colors for data list
    $pre_defined_colors = $plugin_cf['swiper']['swiper-tab_pre-defined-colors'];

    // script for color-picker
    $bjs .= '<script src="' . $pth['folder']['plugins']
         . 'swiper/js/swiper_tab.min.js"></script>';

    $view = '<p><b>' . $lang['swiper-form_title'] . '</b></p>';

    // color-picker
    foreach ($my_fields as $field) {
        if($field == 'sw_slider_bgcolor') {
            $view .= '<input title="color picker" type="color" id="set-Slider-bg-Color" value="'
                  . XH_hsc($page[$field]) . '">
                  <button onclick="slider_bg_Color()">'
                  . $lang['swiper-color-picker_submit']
                  . '</button>';
        }
    }

    // form
    $view .="\n" . '<form action="' . $sn . '?' . $su
          . '" method="post" id="swiper">';
    foreach ($my_fields as $field) {
        if($field == 'sw_slider_bgcolor') {
            $element = '<input maxlength="30" type="text" 
                        id="Slider-bg-Color" 
                        list="Slider-bg-Color_DATA" 
                        class="xh_setting 
                        swiper" size="50"' 
                     . ' name="' . $field . '" value="' 
                     . XH_hsc($page[$field]) . '">';
            $element .= op_SW_DatatList($pre_defined_colors, 'Slider-bg-Color_DATA');
        }
        /*elseif($field == 'sw_slider_bgimg') {
            $element   = '<input maxlength="70" type="text" class="xh_setting swiper" size="50"' 
                       . ' name="' . $field . '" value="'
                       . XH_hsc($page[$field]) . '">';
        }*/
        elseif($field == 'sw_slider_bgimg') {
            $element = '<select class="xh_setting swiper"' 
                     . ' name="' . $field . '" value="' 
                     . XH_hsc($page[$field]) . '">' 
                     . (XH_hsc($page[$field]) != '' 
                     ? '<option>' . XH_hsc($page[$field]) . '</option>' 
                     . '<option></option>' 
                     . str_replace('<option>' . XH_hsc($page[$field]) . '</option>', '', $sw_bgimg_imgdropfield) 
                     : '<option></option>' . $sw_bgimg_imgdropfield) 
                     . '</select>';
        }
        $view .= "\n\t" . XH_helpIcon($lang['swiper-hint_' . $field]) 
              . "\n\t" . '<label><span class="swiper_label">'
              . $lang['swiper-form_' . $field] . '</span>';
        $view .= '<br>' 
            . "\n\t\t" 
            . $element 
            . '</label>' 
            . '<br>';
    }
    $view .= "\n\t" . '<input name="save_page_data" type="hidden">'
        . "\n\t" . '<div style="text-align: right;">'
        . "\n\t\t" . '<input type="submit" value="' . $lang['swiper-form_submit'].'">'
        . '<br>'
        . "\n\t" . '</div>'
        . "\n" . '</form>';
    return $view;
}
